package grapheanim;
/*
la gestion des ouverts est sous la forme d'un tableau de successeur avec pour chaque nom la valeur qui lui est associ.
De cette maniere la valeur reprsente : d(x) + h(x)
*/

import java.io.*;
import java.lang.*;
import java.util.*;
import java.math.*;
import java.awt.*;

/** Algorithme A */
public class A extends Methode_Generale
{
  public A(DynamicGraphData dgd)
  {
    super(dgd);
  }

  //accesseurs
  public String get_Ville_ar() {return DGD.getArrivee();}

  //Methodes
  public void Initialiser()
  {
    super.Initialiser();
  }

  public void Explorer()
  {
    while (!Ouverts.isEmpty())
    {
      String z = Choix();
      System.out.println("Choix : " + z + "  Distance heuristique : " + NOM(z).getHeuristique() + "  Distance : " + NOM(z).getPoid());
      Ajout(z);
      SauverCouleurSommet(Color.blue, z, "\ntant que OUVERTS != {} faire\n   | z <- Choix(OUVERTS)    <--\n   | Ajout(z, FERMES)            <--\n   | Explorer(z)\n   | Virez(z,OUVERTS)", "\nOn choisit comme sommet celui qui a la plus petite valeur\n de 'son poid additionn  son heuristique', parmi les sommets beiges\n");
      int dist = get_Valeur_O(0);
      if (z.equals(DGD.getArrivee()))
      {
        SauverCouleurSommet(Color.green, z, "\ntant que OUVERTS != {} faire\n   | z <- Choix(OUVERTS)\n   | Ajout(z, FERMES)\n   | Explorer(z)\n   | Virez(z,OUVERTS)            <--", "\nComme le dernier sommet trait correspondait au sommet\nd'arrive slectionn, alors le programme s'arrte\nOn peut remarquer qu'il reste des sommets ouverts non traits");
        Virez(z,dist);
        break;
      }
      else
      {
        Exploration(z);
        Virez(z,dist);
        SauverCouleurSommet(Color.green, z, "\ntant que OUVERTS != {} faire\n   | z <- Choix(OUVERTS)\n   | Ajout(z, FERMES)\n   | Explorer(z)\n   | Virez(z,OUVERTS)            <--", "\nUn sommet trait peut tre rouvert ici\nLes sommets peuvent tre plusieurs fois parcourus  ne pas\nconfondre avec l'algorithme de Dijkstra");
      }
    }
    DynamicData DD = new DynamicData();
    DD.setAlgo("\n\n\n     FIN de l'algorithme A*!!\n\n");
    DD.setCommentaire("\nOn constate que suivant le choix de l'heuristique, l'algorithme peut\n acceder directement au sommet souhait ou bien alors reparcourir\n le graphe en rouvrant des sommets dj parcourus!!\n\nRq: Les arrtes blanches indiquent le plus court chemin");
    Vector chemindefinitif = new Vector();
    String essaie = DGD.getArrivee();
    while (!essaie.equals(DGD.getOrigine())) //enregistrement du bon chemin
    {
      chemindefinitif.insertElementAt(essaie,0);
      essaie = NOM(essaie).get_Parent();
    }
    chemindefinitif.insertElementAt(essaie,0);

    for (int i=0;i<Taille();i++) //rinitialisation
    {
      Sommet P = GD().sommetAt(i);
      //if (P.getNom().equals(DGD.getArrivee())) {}
      //else
      if (!P.getNom().equals(DGD.getArrivee()))
      {
        Sommet Old = NOM(P.getNom()).clonePoints();
        for (int j=0;j < P.nbrSuccesseur(); j++)
        {
          P.getSuccesseurAt(j).setCouleur(Color.black);
        }
        P.setCouleur(Color.gray);
        Sommet New = NOM(P.getNom()).clonePoints();
        DD.addSommet(Old, New);
      }
    }

    for (int k=0;k<chemindefinitif.size();k++)
    {
      String sommetdefinitif = (String)chemindefinitif.elementAt(k);
      if (!sommetdefinitif.equals(DGD.getArrivee()))
      {
        String sommetessaie = (String)chemindefinitif.elementAt(k+1);
        Sommet Old = NOM(sommetdefinitif).clonePoints();
        NOM(sommetdefinitif).setCouleur(Color.green);
        NOM(sommetdefinitif).getSuccesseur(sommetessaie).setCouleur(Color.white);
        Sommet New = NOM(sommetdefinitif).clonePoints();
        DD.addSommet(Old, New);
      }
      Sommet Old = NOM(sommetdefinitif).clonePoints();
      NOM(sommetdefinitif).setCouleur(Color.green);
      Sommet New = NOM(sommetdefinitif).clonePoints();
      DD.addSommet(Old, New);
    }
    get_DGD().addStep(DD);
  }

  public void Exploration(String z)
  {
    Vector clone = (Vector)NOM(z).getAllSuccesseurs().clone();//cr un clone des successeurs
    Sommet a = NOM(z);
    int compteur = a.nbrSuccesseur();
    int dist_z = a.get_Dist();
    DynamicData DD2 = new DynamicData();
    DynamicData DD3 = new DynamicData();
    Sommet OldOld = NOM(z).clonePoints(); //on enregistre l'ancien pred.
    Vector garage = new Vector();

    while (compteur != 0) //parcour de tous les successeurs
    {
      int i = Aleatoire(compteur);
      Successeur s = (Successeur)clone.elementAt(i);
      String nom = s.getNom();                  //nom du voisin
      int Val = s.getPoid();                    //valeur associer au voisin
      int dist_y = NOM(nom).get_Dist();         //distance d(y) du voisin
      int result = dist_z + (int)Val;           // d(y) + w(x,y)
      int racine = NOM(nom).getHeuristique();   // heuristique = racine
      int result2 = racine + result;            // d(y) + w(x,y) + h(y)

      if (NOM(nom).get_fermes())
      {
        if (dist_z + Val < dist_y)          //si d(z) + w(z,y) < d(y)
        {
          Insertion(nom,result2);
          etape1(z, nom, result, dist_y, Color.magenta);
          OldOld = NOM(z).clonePoints();
        }
      }
      else if (NOM(nom).get_ouverts())
      {
        if (dist_z + Val < dist_y)
        {
          int distHeuristique = get_Valeur_O(i);
          etape1( z, nom, result, dist_y, Color.magenta);
          Virez(nom, dist_y);      //on rorganiser les OUVERTS
          Insertion(nom, result2);
          OldOld = NOM(z).clonePoints();
        }
      }
      else
      {
        Insertion(nom,result2);
        etape2 ( DD2, DD3, garage, z, nom, result);
      }
      clone.removeElementAt(i);
      compteur--;
    }
    etape3 ( DD2, DD3, OldOld, garage, z);
  }

  public void Afficher()
  {
    System.out.println("\nVille de dpart : " + DGD.getOrigine());
    System.out.println("---------------");
    System.out.println("Ville d'arrive : " + DGD.getArrivee());
    System.out.println("---------------");
    String z = DGD.getOrigine();
    String y = DGD.getArrivee();
    String a = z;
    String x = "";
    while (a.equals(z))
      if (y.equals(DGD.getOrigine())) a = "fin";
      else
      {
        x = NOM(y).get_Parent();
        System.out.println("Le parent de  " + y + "  est  " + x);
        y = x;
      }
    System.out.println("la distance minimale entre " + DGD.getOrigine() + " et " + DGD.getArrivee() + " est de : " + NOM(DGD.getArrivee()).get_Dist() + " Km\n");
  }

}
