package grapheanim;
/*
la gestion des ouverts est sous la forme d'un tableau de successeur avec pour chaque nom la valeur qui lui est associ.
De cette maniere la valeur reprsente : d(x) + h(x)
*/

import java.io.*;
import java.lang.*;
import java.util.*;
import java.math.*;
import java.awt.*;

/** Algorithme A* */
public class A_vol extends  A {

    //declaration des variables
    protected int echelle;

    //mthodes li  l'algo A*
    public int h(int x,int y) { //dans le cas ou l'on prend comme heuristique la distance  vol d'oiseaux
  int x1 = NOM_X(DGD.getArrivee());
  int y1 = NOM_Y(DGD.getArrivee());
  int result = ((Math.abs(x1 - x)) + (Math.abs(y1 - y)));
  return result;
    }

    public A_vol(DynamicGraphData dgd) {
  super(dgd);
    }

    //mthodes

    public void Initialiser() {
  super.Initialiser();
  for (int i=0;i<Taille();i++) {
      Sommet p = (Sommet)(GD().sommetAt(i));
      if ((p.get_Nom()).equals(get_Ville_ar())) {}
      else {
    int r = h(p.get_X(),p.get_Y());
    p.set_h(r);
      }
  }
    }

    public void Explorer() {
  while (Ouverts.isEmpty() == false) {
      String z = Choix();
      System.out.println("Choix : " + z + "  Distance heuristique : " + NOM(z).getHeuristique() + "  Distance : " + NOM(z).getPoid());
      Ajout(z);
      SauverCouleurSommet(Color.blue, z, "\ntant que OUVERTS != {} ou bien z = Arrivee faire\n   | " + z + " <- Choix(OUVERTS)    <--\n   | Ajout(" + z + ", FERMES)            <--\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)", "\nOn choisit comme sommet celui qui a la plus petite valeur\n de 'son poid additionn  son heuristique', parmi les sommets beiges\n");
      int dist = get_Valeur_O(0);
      if (z.equals(DGD.getArrivee())) {
    SauverCouleurSommet(Color.green, z, "\ntant que OUVERTS != {} ou bien z = Arrivee faire\n   | " + z + " <- Choix(OUVERTS)\n   | Ajout(" + z + ", FERMES)\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)            <--", "\nComme le dernier sommet trait correspondait au sommet\nd'arrive slectionn, alors le programme s'arrte\nOn peut remarquer qu'il peut rester des sommets ouverts non traits");
    Virez(z,dist);
    break;
      }
      else {
    Exploration(z);
    Virez(z,dist);
    SauverCouleurSommet(Color.green, z, "\ntant que OUVERTS != {} ou bien z = Arrivee faire\n   | " + z + " <- Choix(OUVERTS)\n   | Ajout(" + z + ", FERMES)\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)            <--", "\nContrairement a l'algorithme A* classique, les sommets \nferms ne se rouvrent pas ici, du fait du choix de l'heuristique\n");
      }
  }
  DynamicData DD = new DynamicData();
  DD.setAlgo("\n\n\n     FIN de l'algorithme A!!\n\n");
  DD.setCommentaire("\nCet algorithme particulier de A* nous montre une\ntechnique immdiate pour trouver le chemin le plus court\n, cependant il est a noter qu'une valuation excessive de \ncertaines arrtes provoque des rsultats quivalent\n  dijkstra voire rrons");
  Vector chemindefinitif = new Vector();
  String essaie = DGD.getArrivee();
  while (essaie.equals(DGD.getOrigine()) == false) {   //enregistrement du bon chemin
      chemindefinitif.insertElementAt(essaie,0);
      essaie = NOM(essaie).get_Parent();
  }
  chemindefinitif.insertElementAt(essaie,0);

  for (int i=0;i<Taille();i++) {     //rinitialisation
      Sommet P = GD().sommetAt(i);
      if (P.getNom().equals(DGD.getArrivee()) == true) {}
      else {
    Sommet Old = NOM(P.getNom()).clonePoints();
    for (int j=0;j < P.nbrSuccesseur(); j++) {
        P.getSuccesseurAt(j).setCouleur(Color.black);
    }
    P.setCouleur(Color.gray);
    Sommet New = NOM(P.getNom()).clonePoints();
    DD.addSommet(Old, New);
      }
  }

  for (int k=0;k<chemindefinitif.size();k++) {
      String sommetdefinitif = (String)chemindefinitif.elementAt(k);
      if (sommetdefinitif.equals(DGD.getArrivee()) == false) {
    String sommetessaie = (String)chemindefinitif.elementAt(k+1);
    Sommet Old = NOM(sommetdefinitif).clonePoints();
    NOM(sommetdefinitif).setCouleur(Color.green);
    NOM(sommetdefinitif).getSuccesseur(sommetessaie).setCouleur(Color.white);
    Sommet New = NOM(sommetdefinitif).clonePoints();
    DD.addSommet(Old, New);
      }
      Sommet Old = NOM(sommetdefinitif).clonePoints();
      NOM(sommetdefinitif).setCouleur(Color.green);
      Sommet New = NOM(sommetdefinitif).clonePoints();
      DD.addSommet(Old, New);
  }
  get_DGD().addStep(DD);
    }


};
