package grapheanim;

import java.io.*;
import java.awt.*;
import java.lang.*;
import java.util.*;

/** Algorithme de Dijkstra */
public class Dijkstra extends Methode_Generale {
    //Constructeur
    public Dijkstra(DynamicGraphData dgd) {
  super(dgd);
    }

    //Methodes
  public void Explorer() {
    while (Ouverts.isEmpty() == false) {
      String z = Choix();
      Ajout(z);
      SauverCouleurSommet(Color.blue, z, "\ntant que OUVERTS != {} faire\n   | " + z + " <- Choix (OUVERTS)    <--\n   | Ajout (" + z + ", FERMES)            <--\n   | Explorer (" + z + ")\n   | Virez (" + z + ",OUVERTS)", "\nOn choisit comme sommet celui qui a la plus\npetite valeur parmi les sommets beiges (les sommets OUVERTS)\n");
      int dist = get_Valeur_O(0);
      Exploration(z);
      Virez(z,dist);
      SauverCouleurSommet(Color.green, z, "\ntant que OUVERTS != {} faire\n   | " + z + " <- Choix (OUVERTS)\n   | Ajout (" + z + ", FERMES)\n   | Explorer (" + z + ")\n   | Virez (" + z + ",OUVERTS)            <--", "\nUn sommet trait n'est plus jamais rouvert\nOn ne parcours donc les sommets qu'une et une seule fois avec\n l'algorithme de Dijkstra");
    }
  DynamicData DD = new DynamicData();
  DD.setAlgo("\n\n\n     FIN de l'algorithme Dijkstra!!\n\n");
  DD.setCommentaire("\nTous les sommets ont t traits donc l'algorithme \ndonne bien au final les plus courts chemins partant de l'origine\n\nVous n'avez qu' suivre les arrtes blanches!!!\n");
  get_DGD().addStep(DD);
    }

    public void Exploration(String z) {
  Vector clone = (Vector)NOM(z).getAllSuccesseurs().clone();//cr un clone des successeurs
  Sommet a = NOM(z);
  int compteur = a.nbrSuccesseur();
  int dist_z = a.get_Dist();
  DynamicData DD2 = new DynamicData();
  DynamicData DD3 = new DynamicData();
  Sommet OldOld = NOM(z).clonePoints(); //on enregistre l'ancien pred.
  Vector garage = new Vector();

  while (compteur != 0) {                //parcour de tous les successeurs
      int i = Aleatoire(compteur);
      Successeur s = (Successeur)clone.elementAt(i);
      String nom = s.getNom();
      int val = s.getPoid();
      int dist_y = NOM(nom).get_Dist();
      int result = dist_z + (int)val;

      if (NOM(nom).get_fermes()) {}
      else {
    if (NOM(nom).get_ouverts()) {
        if (dist_z + val < dist_y) {
      etape1(z, nom, result, dist_y,Color.magenta);
      Virez(nom, dist_y);      //Virez et inserer sont la pour rorganiser les OUVERTS
      Insertion(nom, result);
      OldOld = NOM(z).clonePoints();
        }
    }
    else {
        Insertion(nom,result);
        etape2 (DD2, DD3, garage, z, nom, result);
    }
      }
      clone.removeElementAt(i);
      compteur--;
  }
  etape3 ( DD2, DD3, OldOld, garage, z);
    }

    public void Afficher() {
  System.out.println("\nVille de depart " + get_Ville_depart());
  System.out.println("---------------");
  System.out.println("Voici la liste des parents de chacune des villes");
  System.out.println("-----------------------------------------------\n");
  for (int i=0;i<Taille();i++) {
      Sommet p = (Sommet)(GD().sommetAt(i));
      System.out.println("Ville : " + p.get_Nom());
            System.out.println("Parent : " + p.get_Parent());
      System.out.println("Distance minimale : " + p.get_Dist() + "\n");
  }
    }
};
