package grapheanim;

import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.io.*;
import java.math.*;
import java.util.Vector;

/** Fentre principale de l'diteur de graphes. */
public class Editeur extends Frame implements ActionListener, WindowListener
{
  //private static int nbr_fenetre = 0;   //nbr de fenetre ouverte, si == 0 on quitte
  private MenuItem nouveau, fermer, quitter, propos, anime;

  // Cree une Frame, un Menu, et un ScrollPane pour le component Graphe
  public Editeur(int i)
  {
    // Creation de la fenetre
    super("Editeur de graphe");
    this.setBounds(50,50,800,600);
    setLayout (new BorderLayout());
    Anime.nbr_fenetre++;
    if (i != 0) Anime.nbr_fenetre = i + 1;
    ScrollPane pane = new ScrollPane();
    pane.setSize(640, 400);
    this.add(pane, BorderLayout.CENTER);
    Graphe graphe = new Graphe(this);
    pane.add(graphe);
    // Creation de la barre de menu
    MenuBar leMenu = new MenuBar();
    this.setMenuBar(leMenu);
    Menu fichier = new Menu("Fichier");
    leMenu.add(fichier);
    Menu aide = new Menu("Aide");
    leMenu.add(aide);
    fichier.add(nouveau = new MenuItem("Nouveau editeur", new MenuShortcut(KeyEvent.VK_E)));
    fichier.add(fermer = new MenuItem("Fermer editeur",new MenuShortcut(KeyEvent.VK_F)));
    fichier.add(anime = new MenuItem("Nouveau anime",new MenuShortcut(KeyEvent.VK_A)));
    fichier.addSeparator();
    fichier.add(quitter = new MenuItem("Quitter", new MenuShortcut(KeyEvent.VK_Q)));
    aide.add(propos = new MenuItem("A propos"));
    nouveau.addActionListener(this);
    fermer.addActionListener(this);
    quitter.addActionListener(this);
    propos.addActionListener(this);
    anime.addActionListener(this);
    // permet de fermer le programme avec la croix  de la fenetre
    this.addWindowListener(this);
    // affichage de la fenetre
    this.pack();
    this.show();
  }

  /** vnement de fermeture */
  public void windowClosing(WindowEvent evt)
  {
    if (--Anime.nbr_fenetre == 0) System.exit(0);
    else dispose();
  }
  public void windowClosed(WindowEvent evt) { }
  public void windowDeiconified(WindowEvent evt) { }
  public void windowIconified(WindowEvent evt) { }
  public void windowActivated(WindowEvent evt) { }
  public void windowDeactivated(WindowEvent evt) { }
  public void windowOpened(WindowEvent evt) { }

  public void  actionPerformed (ActionEvent evt)
  {
    Object obj = evt.getSource();
    if (obj == nouveau) new Editeur(0);
    else if (obj == anime) new Anime(Anime.nbr_fenetre);
    else if (obj == quitter) System.exit(0);
    else if (obj == propos) new APropos(this, "Editeur de graphe\n \n\nUtilisation:\n1 clique gauche = 1 sommet\n1 clique droit = menu popup\n1 drag gauche entre 2 sommets = 1 arete\nmettre 0 pour annuler l'arc\n\n");
    else if (obj == fermer) windowClosing(null);
    /*{
      if (Anime.--nbr_fenetre == 0) System.exit(0);
      else dispose();
    }*/
  }

  public static void main(String[] args) { new Editeur(0); }

}
