package grapheanim;

import java.io.*;
import java.lang.*;
import java.lang.Object;
import java.util.*;
import java.awt.*;

/** Algorithme de parcours lexicographique. */
public class Lexico extends Methode_Generale {
    //Variable
    //~~~~~~~~
    protected int numero_courant;

    //Constructeurs
    //~~~~~~~~~~~~~
    Lexico(DynamicGraphData dgd) {
  super(dgd);
    }

    //Affectation
    //~~~~~~~~~~~
    public void set_nc(int a) {numero_courant = a;}

    //Accesseur
    //~~~~~~~~~
    public int get_nc() {return numero_courant;}

    //Mthodes
    //~~~~~~~~

    public String ItoS(int i) {  //change le type "int" -> "String"
  Integer I = new Integer(i);
  String S = I.toString(i);
  return S;
    }

    public void Initialiser() {
  super.Initialiser();
  int nc = Taille();     //nbre de sommets
  numero_courant = nc;
  String z = get_Ville_depart();
  set_Valeur_O(nc+1,0);   //nc + 1 car cela permet de virez le dernier tout le temps
  for (int i=0;i<Taille();i++) {
      Sommet P = GD().sommetAt(i);
      P.setHeuristique(0);
  }
  NOM(z).set_Dist_Lexico("");
    }

    public void Explorer() {
  while (Ouverts.isEmpty() == false) {
      String z = Choix();
      Reorganisez(z);
      NOM(z).setHeuristique(numero_courant);
      SauverCouleurSommet(Color.blue, z, "\ntant que OUVERTS != {} faire\n   | " + z + " <- Choix(OUVERTS)    <--\n   | Ajout(" + z + ", FERMES)            <--\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)", "\nOn choisie comme sommet celui qui  la plus grande valeur \nlexicographique parmi les sommets beiges(les sommets OUVERTS)\npar exemple : 6.5 > 6 ou bien 11.3.2 > 11.3.1");
      Ajout(z);
      Exploration(z);
      Virez(z);
      SauverCouleurSommet(Color.green, z, "\ntant que OUVERTS != {} faire\n   | " + z + " <- Choix(OUVERTS)\n   | Ajout(" + z + ", FERMES)\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)            <--", "\nUn sommet trait n'est plus jamais rouvert\nOn ne parcours les sommets donc qu'une et une seule fois\n");
      numero_courant--;
  }
  DynamicData DD = new DynamicData();
  DD.setAlgo("\n\n     FIN de l'algorithme de\n parcours en largeur lexicographique!!\n\n");
  DD.setCommentaire("\nA la fin on obtient bien une numerotation compatible des sommets.\n\nRq: lorsqu'on travaille avec un graphe complet, on constate\nqu'un des sommets possedent  toutes les valeurs \n'entre crochet' des ses sommets");
  get_DGD().addStep(DD);
    }

    public void Exploration(String z) {
  Vector clone = (Vector)NOM(z).getAllSuccesseurs().clone();//cr un clone des successeurs
  int compteur = NOM(z).nbrSuccesseur();
  Sommet OldOld = NOM(z).clonePoints(); //on enregistre l'ancien pred

  while (compteur != 0) { //parcour de tous les successeurs
      int i = Aleatoire(compteur);
      Successeur s = (Successeur)clone.elementAt(i);
      String nom = s.getNom();

      if (NOM(nom).get_fermes()) {}
      else {
    if (NOM(nom).get_ouverts()) {
        DynamicData DD = new DynamicData();
        DD.setAlgo("\nExplorer\n  ....\nsi "+ nom + " appartient aux OUVERTS alors\n      | d (" + nom + ") <- d (" + nom + ")  numero (" + z + ")    <--\n");
        DD.setCommentaire("\nOn affecte le sommet voisin : '" + nom + "',par la concatnation entre la distance \nlexcicographique de '" + nom + "' qui  est : " + NOM(nom).get_Dist_Lexico() + " ,et le \nnumero courant : " + numero_courant + " du sommet " + z + "\n\nle symbole '  ' reprsente la fonction de concatnation");
        Sommet Old = NOM(nom).clonePoints();   //on enregistre l'ancien Point;
        String S = NOM(nom).get_Dist_Lexico();
        String R = S.concat(numero());
        NOM(nom).set_Dist_Lexico(R);  //on met le resultat dans le voisin
        NOM(nom).set_Parent(z);
        Sommet New = NOM(nom).clonePoints();   //on enregistre le nouveau Point;

        NOM(z).getSuccesseur(nom).setCouleur(Color.white);
        Sommet NewNew = NOM(z).clonePoints();
        DD.addSommet(OldOld, NewNew);
        Reorganisez(nom);
        OldOld = NewNew;

        DD.addSommet(Old, New);
        get_DGD().addStep(DD);
    }
    else {
        DynamicData DD = new DynamicData();

        Sommet Old = NOM(nom).clonePoints();   //on enregistre l'ancien Point;
        NOM(nom).set_Parent(z);
        NOM(nom).set_Dist_Lexico(numeroSansPoint());
        Insertion(nom);  //on  besoin de la distance lexicographique pour insertion
        NOM(nom).setCouleur(beige);
        Sommet New = NOM(nom).clonePoints();   //on enregistre le nouveau Point;
        DD.addSommet(Old, New);

        NOM(z).getSuccesseur(nom).setCouleur(Color.white);
        Sommet NewNew = NOM(z).clonePoints();
        DD.addSommet(OldOld, NewNew);
        OldOld = NewNew;
        DD.setAlgo("\npour tous les voisins y de " + z + " faire\n   .....\n    sinon\n      | d (" + nom + ") <- d (" + nom + ")  numero (" + z + ")  <--\n      | Ajout (" + nom + ", OUVERTS)            <--");
        DD.setCommentaire("\nOn affecte le sommet voisin : '" + nom + "',par la concatnation entre\nla distance lexcicographique de '" + nom + "' qui  est : vide  ,et le \nnumero courant : " + numero_courant + " du sommet " + z + "\n\nle symbole '  ' reprsente la fonction de concatnation");
        get_DGD().addStep(DD);
    }
      }
      clone.removeElementAt(i);
      compteur--;
  }
    }

    public String Choix() {                  //on choisie le dernier elt. (le plus grand)
  String z = get_Voisin_O(get_nb_ouverts() - 1);
  String S = NOM(z).get_Dist_Lexico();
  String R = "";
  if (S.equals("") == true) {
      R = S.concat(numeroSansPoint());
  }
  else {
      R = S.concat(numero());
  }
  NOM(z).set_Dist_Lexico(R);  //on met le resultat dans le voisin
  return z;
    }

    public void Virez(String z) { //on ne peut pas virez le dernieer  cause de la rorganisation
  String test = "";
  int i=-1;
  while (test.equals(z) == false) {
      i++;
        test = get_Voisin_O(i);
  }
  Ouverts.removeElementAt(i);
  NOM(z).set_ouverts(false);
  nb_ouverts--;
    }

    public void Insertion(String z) {
  int i = 0;
  int fin = 1;
  while(fin == 1) {
      if (nb_ouverts == 0 || i > (nb_ouverts - 1)) {
    INSERT_O(z, 0,i);
    fin = 0;
      }
      else {
    String valeuropposant = NOM(get_Voisin_O(i)).getDistLexico();
    String valeur =  NOM(z).getDistLexico();
    int result = valeur.compareTo(valeuropposant);

    if (result < 0 || result == 0) { //result < 0 -> valeur < valeuropposee
        INSERT_O(z, 0, i);
        fin = 0;
    }
  }
  i++;
    }
    NOM(z).set_ouverts(true);
    nb_ouverts++;
}

    public String numero() {
  String S = ItoS(get_nc());
  String R = ".";
  String T = R.concat(S);
  return T;}

    public String numeroSansPoint() { return ItoS(get_nc()); }

    public int CtoI (char C) {
  Character CH = new Character(C);
  String S = CH.toString();
  Integer I = new Integer(S);
  int i = I.intValue();
  return i;
    }

    public void Reorganisez(String nom) {
  Virez(nom);
  Insertion(nom);       //Virez et inserer sont la pour rorganiser les OUVERTS
    }

    public void Afficher() {
  System.out.println("Affichons le parcour en largeur Lexicogarphique");
  System.out.println("-----------------------------------------------\n");
  for (int i=0;i<Taille();i++) {
      Sommet p = (Sommet)(GD().sommetAt(i));
      System.out.println("Ville : " + p.get_Nom());
            System.out.println("Parent : " + p.get_Parent());
      System.out.println("Son numero de sommet est : " + p.getHeuristique());
      System.out.println("Distance lexicographoque : " + p.get_Dist_Lexico() + "\n");
  }
    }
};
