package grapheanim;

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.lang.Thread.*;

//Afin de remdier au probleme du Choix on va faire une structure de Ouvert trie lors de l'arriv des points : les points seront tri par apport a leur distance

/** Mthodes communes  tous les algorithmes. */
public abstract class Methode_Generale extends Object
{
  //declaration des variables
  /**Reprsentation de toutes les tapes de l'algo */
  protected DynamicGraphData DGD;
  protected Vector Ouverts = new Vector();
  protected int nb_ouverts;
  //protected Color bleutet = new Color(82,167,236);
  protected Color beige = new Color(238,208,161);

  //constructeur
  public Methode_Generale(DynamicGraphData dgd)
  {
    DGD = new DynamicGraphData(dgd);
    Ouverts.insertElementAt(new Successeur(DGD.getOrigine(),0),0);
    nb_ouverts = 1;
  }

  //accesseurs
  public DynamicGraphData get_DGD() {return DGD;}
  public GrapheData GD() {return DGD.getInitGraph();}
  public String get_Ville_depart() {return DGD.getOrigine();}
  public int get_nb_ouverts() {return nb_ouverts;}

  //affectations
  public void set_DGD(DynamicGraphData dgd) {DGD = dgd;}
  public void set_nb_ouverts(int i) {nb_ouverts = i;}
  public void set_Valeur_O(int val,int place) {GET_O(place).setPoid(val);}

  //Gestion de la table de Hashage
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public Sommet NOM(String ville)
  {
    for(int i = 0; i < Taille(); i++)
    {
      if (GD().sommetAt(i).getNom().equals(ville))
      return GD().sommetAt(i);
    }
    return null;
  }

  public int NOM_X(String ville) {return NOM(ville).get_X();}
  public int NOM_Y(String ville) {return NOM(ville).get_Y();}

  //Gestion des ouverts
  public void INSERT_O(String voisin,int val, int d) {Ouverts.insertElementAt(new Successeur(voisin,val), d);}
  public Successeur GET_O(int d) {return (Successeur)Ouverts.elementAt(d);}
  public String get_Voisin_O(int place) {return GET_O(place).getNom();}
  public int get_Valeur_O(int place) {return GET_O(place).getPoid();}

  //Methodes

  public int Aleatoire(int compteur) //fonction alatoire entre 0 et compteur - 1
  {
    return (int)(Math.abs(Math.random()*compteur));
  }

  public int Taille() {return GD().getAllSommets().size();}

  //Methode li a l'Algorithme

  /** Initialisation du graphe */
  public void Initialiser()
  {
    for (int i = 0; i < Taille(); i++)
    {
      Sommet P = GD().sommetAt(i);
      for (int j=0;j < P.nbrSuccesseur(); j++)
        P.getSuccesseurAt(j).setCouleur(Color.black);
      P.setCouleur(Color.gray);
      P.set_Dist(100000);
      P.set_fermes(false);
    }
    DynamicData DD =new DynamicData();
    DD.setAlgo("\nOUVERTS <- { " + DGD.getOrigine() + " } , FERMES <- { }\nParent(" + DGD.getOrigine() + ") <- NIL\npour tout y!='" + DGD.getOrigine() + "' Parent(y) <- y\nd(" + DGD.getOrigine() + ") <- lment minimal de T\npour tout y!='" + DGD.getOrigine() + "', d(y) <- lment maximal de T");
    DD.setCommentaire("\nINITIALISATION de l'algorithme\n- '" + DGD.getOrigine() + "' correspond au sommet de dpart\n- T pour l'ensemble des valuations des arrtes du graphe\n- Parent () est la fonction qui renvoie son prdeccesseur\n- d () est la fonction qui renvoie la distance du sommet  l'origine");

    Sommet sommet_origine = NOM(DGD.getOrigine());
    Sommet Old = sommet_origine.clonePoints();
    sommet_origine.setCouleur(beige);
    Sommet New = sommet_origine.clonePoints();
    DD.addSommet(Old, New);

    get_DGD().addStep(DD);
    sommet_origine.set_Parent("NIL"); //on met le parent  'NIL'
    sommet_origine.set_Dist(0); //on met l'element minimal de T dans d(x)
    sommet_origine.set_ouverts(true);
    //NOM(DGD.getOrigine()).set_Parent("NIL");    //on met le parent  'NIL'
    //NOM(DGD.getOrigine()).set_Dist(0);          //on met l'element minimal de T dans d(x)
    //NOM(DGD.getOrigine()).set_ouverts(true);
  }

  public String Choix() {return get_Voisin_O(0);} //on prend le premier
  public void Ajout(String z) {NOM(z).set_fermes(true);}
  //public abstract void Explorer(String z);

  /**
   * Fonction de trie de ouverts.
   * Cration du tableau tri par ordre croissant des sa cration : Complexit O(n) ou 'n' est le nbre de ses voisins.
   */
  public void Insertion(String voisin,int val)
  {
    int maxi = get_nb_ouverts();
    int mini = 0;
    int d = 0;
    int fin = 0;
    while (fin != 1)
    {
      d = (maxi+mini)/2;
      if (val>get_Valeur_O(d))
      {
        if (GET_O(d).equals((Successeur)Ouverts.lastElement())) //si c'est le dernier elt
        {
          INSERT_O(voisin, val, d+1);
          fin = 1;
        }
        else if (val < get_Valeur_O(d + 1)) //si la valeur du suivant est suprieure  celle rentrer
        {
          INSERT_O(voisin, val, d + 1);
          fin = 1;
        }
        else mini = d;//la valeur  rentrer se trouve dans la demi-moitier suprieure du tableau
      }
      else if (GET_O(d).equals(Ouverts.firstElement()))
      {
        INSERT_O(voisin, val, d);
        fin = 1;
      }
      else if (val > get_Valeur_O(d - 1))
      {
        INSERT_O(voisin, val, d);
        fin = 1;
      }
      else maxi = d;
    }
    NOM(voisin).set_ouverts(true);
    nb_ouverts++;
  }

  public void Virez(String z, int dist)
  {
    int maxi = nb_ouverts;
    int mini = 0;
    int fin = 0;
    int d = 0;
    while (fin != 1)
    {
      d = (maxi + mini)/2;
      if (get_Voisin_O(d).equals(z))
      {
        Ouverts.removeElementAt(d);
        fin = 1;
      }
      else if (dist > get_Valeur_O(d)) mini = d;
      else maxi = d;
    }
    NOM(z).set_ouverts(false);
    nb_ouverts--;
  }

  //Mthodes lies  l'xcution de l'algorithme

  public String ouvertfermes()
  {
    String ouvert ="";
    for (int j=0;j<nb_ouverts;j++) ouvert += get_Voisin_O(j) + " ";
    String ferme = "";
    for (int i=0;i<Taille();i++)
      if (GD().sommetAt(i).get_fermes() == true)
        ferme += GD().sommetAt(i).getNom() + " ";
    String result = "OUVERTS : " + ouvert + "\n" + "FERMES   : " + ferme;
    return result;
  }

  public String donnervoisin(String z)
  {
    String result = "";
    for (int i=0;i<NOM(z).nbrSuccesseur();i++)
      result += NOM(z).getSuccesseurAt(i).getNom() + "  ";
    return result;
  }

  public void SauverPoints(Sommet Old , Sommet New)
  {
    DynamicData DD =new DynamicData();
    DD.addSommet(Old, New);
    get_DGD().addStep(DD);
  }

  public void SauverCouleurSommet(Color C, String z) //sauve sommet par sommet
  {
    Sommet Old = NOM(z).clonePoints(); //on enregistre l'ancien pred.
    NOM(z).setCouleur(C);
    Sommet New = NOM(z).clonePoints();  //on enregistre le nouveau Point;
    SauverPoints(Old, New);
  }

  public void SauverPoints(Sommet Old , Sommet New, String phrase, String comment)
  {
    DynamicData DD =new DynamicData();
    DD.addSommet(Old, New);
    DD.setAlgo( phrase );
    DD.setCommentaire(comment + "\n" + ouvertfermes());
    get_DGD().addStep(DD);
  }

  public void SauverCouleurSommet(Color C, String z, String phrase, String comment) //sauve sommet par sommet
  {
    Sommet Old = NOM(z).clonePoints(); //on enregistre l'ancien pred.
    NOM(z).setCouleur(C);
    Sommet New = NOM(z).clonePoints();  //on enregistre le nouveau Point;
    SauverPoints(Old, New, phrase, comment);
  }

  public void SauverCouleurArrete(DynamicData DD, Color C,String z, String nom) //sauve les arretes
  {
    Sommet Old = NOM(z).clonePoints(); //on enregistre l'ancien pred.
    NOM(z).getSuccesseur(nom).setCouleur(C);
    Sommet New = NOM(z).clonePoints(); //on enregistre le nouveau Point;
    DD.addSommet(Old, New);
  }

  public void etape1(String z, String nom, int result, int dist_y, Color C)
  {
    DynamicData DD = new DynamicData();
    DynamicData DD1 = new DynamicData();
    String ancienNom = NOM(nom).get_Parent();

    Sommet Old1 = NOM(nom).clonePoints(); //on enregistre l'ancien Points;
    NOM(nom).setCouleur(C);
    Sommet New1 = NOM(nom).clonePoints(); //on enregistre le nouveau Point;
    DD.addSommet(Old1, New1);

    if (ancienNom.equals(z))
    {
      SauverCouleurArrete(DD, C, z, nom);

      DD.setAlgo("\nsi '" + nom + "' appartient aux FERMES alors\n   si d (" + z + ") + w (" + z + "," + nom + ") < d (" + nom + ") alors   <--\n      | Parent (" + nom + ") <- " + z + "\n      | d (" + nom + ") <- d (" + z + ") + w (" + z + "," + nom + ")\n      | Ajout (" + nom + ", OUVERTS) ");
      DD.setCommentaire("\nOn ouvre  nouveau le sommet ferm\n\nFaites attention, ici un sommet peut-tre parcouru plusieurs fois\nc'est pourquoi suivant les heuristiques choisies, l'algorithme \nsera trs rapide ou au contraite trs lent.");
      get_DGD().addStep(DD);  //UN PAS

      SauverCouleurArrete(DD1, Color.white, z, nom);
    }
    else
    {
      SauverCouleurArrete(DD, C, ancienNom, nom);
      SauverCouleurArrete(DD, Color.white, z, nom);

      DD.setAlgo("\nsi '" + nom + "' appartient aux OUVERTS alors\n   si d (" + z + ") + w (" + z + "," + nom + ") < d (" + nom + ") alors   <--\n      | Parent (" + nom + ")  <- " + z + "\n      | d (" + nom + ") <- d (" + z + ") + w (" + z + "," + nom + ")\n");
      DD.setCommentaire("\nChangement d'arrte.\nOn a trouv un chemin plus court entre le point\n'" + DGD.getOrigine() + "' et le point '" + nom + "'.\n\n");
      get_DGD().addStep(DD);  //UN PAS

      SauverCouleurArrete(DD1, Color.black, ancienNom, nom);
    }

    NOM(nom).setCouleur(beige);
    NOM(nom).set_Parent(z);
    NOM(nom).set_Dist(result);
    Sommet New2 = NOM(nom).clonePoints();    //on enregistre le nouveau Point;
    DD1.addSommet(New1, New2);
    DD1.setAlgo("\nsi '" + nom +"' appartient aux OUVERTS alors\n   si d (" + z + ") + w (" + z + "," + nom +") < d (" + nom +") alors\n      | Parent (" + nom + ") <- " + z + "                 <--\n      | d (" + nom + ") <- d (" + z + ") + w (" + z + "," + nom + ")      <--\n");
    DD1.setCommentaire("\nLorsque tous les points seront trait alors les arrtes blanches\nseront les plus courts chemins de l'origine\nRq: le nouveau chemin constuti jusqu' prsent, est le plus \n     court chemin potentiel mais ne constitue pas pas\n forcment le chemin dfinitif!!");
    get_DGD().addStep(DD1);  //DEUX PAS
  }

  public void etape2 (DynamicData DD2,DynamicData DD3,Vector garage,String z,String nom,int result)
  {
    Sommet Old = NOM(nom).clonePoints();   //on enregistre l'ancien Point;
    NOM(nom).setCouleur(Color.red);
    Sommet New = NOM(nom).clonePoints();   //on enregistre le nouveau Point;
    DD2.addSommet(Old, New);

    NOM(nom).set_Dist(result);
    NOM(nom).set_Parent(z);
    Sommet New1 = NOM(nom).clonePoints();   //on enregistre le nouveau Point;
    DD3.addSommet(New, New1);

    String essaie = new String(nom);
    garage.insertElementAt(essaie,0);
  }

  public void etape3 (DynamicData DD2,DynamicData DD3,Sommet OldOld,Vector garage,String z)
  {
    //if (garage.size()==0) {}
    //else
    if (garage.size()!=0)
    {
      for(int j=0;j<garage.size();j++)
      {
        String voiture = (String)garage.elementAt(j);
        NOM(z).getSuccesseur(voiture).setCouleur(Color.white); //on colore les arretes
        Sommet Old = NOM(voiture).clonePoints();
        NOM(voiture).setCouleur(beige);
        Sommet New = NOM(voiture).clonePoints();
        DD3.addSommet(Old, New);
      }
      DD2.setAlgo("\nExplorer (" + z + ")\n...sinon\n      | Ajout (y,OUVERTS)         <--\n      | Parent (y) <- " + z + "               <--\n      | d (y) <- d (" + z + ") + w (" + z + ",y)");
      DD2.setCommentaire("\nOn traite les voisins de : '" + z + "'\nSes voisins n'appartiennent ni aux OUVERTS ni au FERMES\n\nles 'y' reprsentent l'ensemble de ses voisins c.a.d :\n" + donnervoisin(z));
      get_DGD().addStep(DD2);  //d'abord on affiche les sommets

      Sommet NewNew = NOM(z).clonePoints(); //on enregistre le nouveau Point;
      DD3.addSommet(OldOld, NewNew);

      DD3.setAlgo("\nExplorer (" + z + ")\n...sinon\n      | Ajout (y,OUVERTS)\n      | Parent (y) <- " + z + "\n      | d (y) <- d (" + z + ") + w (" + z + ",y)     <--");
      DD3.setCommentaire("\nOn affecte les valeurs des arretes aux sommets\nLes arrtes en blanc indiquent le plus court chemin\n la fin de CETTE tape.\n\n");
      get_DGD().addStep(DD3);  //on affiche les arretes
    }
  }

  //Affichage
  public void Afficher_Ville(String Ville)
  {
    System.out.println("Nom de la Ville  : " + Ville);
    System.out.println("Nbres de voisins : " + NOM(Ville).nbrSuccesseur());
    for (int i=0;i<NOM(Ville).nbrSuccesseur();i++)
      System.out.println("Ville : " + NOM(Ville).get_Voisin_S(i) +"   Distance : " + NOM(Ville).get_Valeur_S(i) + " Km");
    System.out.println("\n");
  }

}
