package grapheanim;

/**
 * Description : Equivalent "light" de la classe <CODE>Integer</CODE> avec une mthode <CODE>setIntValue()</CODE> en plus.
 * @author <A href=http://www.alapetite.fr.st target=_blank>Alexandre Alapetite</A> & <A href=http://www.andujar.fr.st target=_blank>Brice Andujar</A>
 * @version 1.0
 * @see java.lang.Integer
 */
public class PInteger extends Object implements Comparable
{
  /**Seul attribut. <CODE>PInteger</CODE> sert donc de pointeur sur entier, avec quelques mthodes en plus*/
  private int value;

  /**Constructeur par dfaut, avec la valeur 0*/
  public PInteger()
  {
    this(0);
  }

  public PInteger(int value)
  {
    super();
    this.value=value;
  }

  public int intValue()
  {
    return value;
  }

  /** permet de changer la valeur de l'entier */
  public void setIntValue(int value)
  {
    this.value=value;
  }

  public int compareTo(PInteger anotherInteger)
  {
    int thisVal = this.value;
    int anotherVal = anotherInteger.intValue();
    return (thisVal<anotherVal ? -1 : (thisVal==anotherVal ? 0 : 1));
  }

  public int compareTo(Object o)
  {
    return compareTo((Integer)o);
  }

  public String toString()
  {
    return String.valueOf(value);
  }

}
